import 'dart:io';

import 'package:analyzer/dart/analysis/analysis_context_collection.dart';
import 'package:analyzer/dart/analysis/results.dart';
import 'package:path/path.dart' as p;

extension FileResolution on FileSystemEntity {
  Future<ResolvedUnitResult> resolveFile(
    AnalysisContextCollection collection,
  ) async {
    final absoluteNormlizedPath = p.normalize(this.absolute.path);
    final context = collection.contextFor(absoluteNormlizedPath);
    return (await context.currentSession.getResolvedUnit(absoluteNormlizedPath))
        as ResolvedUnitResult;
  }
}

extension FileExtension on File {
  Future<String?> getContent() async {
    if (await exists()) {
      return this.readAsString();
    }
    return null;
  }
}
