
import 'package:analyzer/dart/ast/ast.dart';

extension StrintExt on String {
  String get shrink {
    String shrinkString = this;
    shrinkString = this.replaceAll(RegExp(r'\s+'), ''); //remove all line spaces
    shrinkString =
        this.replaceAll(RegExp(r'\r|\n'), ''); //remove all line breaks
    return shrinkString;
  }
}

extension PrettyCodeOperations on String {
  String getPrettyCodeForNode(AstNode node, {bool addSemiColon = false}) =>
      substring(node.offset, node.end) + (addSemiColon ? ';' : '');

  String replaceNodeCode(AstNode node, String code) =>
      replaceRange(node.offset, node.end, code);

  String insertAtOffset(int offset, String code) {
    //TODO: If this could also take care of the indentation
    return replaceRange(offset, offset, "\n" + code);
  }
}
