import 'package:welltested/src/extensions/list_extension.dart';
import 'package:welltested/src/models/test_run_info.dart';
import 'package:welltested/src/utilities/logging.dart';

class GenerateRunInfo extends TestRunInfo {
  GenerateRunInfo(int queue, int created, int updated, int failed)
      : super(queue, created, updated, failed);

  factory GenerateRunInfo.newRun() => GenerateRunInfo(0, 0, 0, 0);

  @override
  void pushFunctionInQueue(String functionName) {
    super.pushFunctionInQueue(functionName);
    _updateSpinnerMessage();
  }

  @override
  void incrementFromAction(TestGenerationStatus status, String functionName) {
    super.incrementFromAction(status, functionName);
    _updateSpinnerMessage();
  }

  void _updateSpinnerMessage() {
    if (queue == 0) return;
    var methodList = functionQueue.humanPreferredString(3);
    wtLog.updateSpinnerMessage('Generating Test for ${methodList}...');
  }
}
