import 'package:welltested/src/models/test_run_info.dart';

import '../utilities/logging.dart';

class SaveRunInfo extends TestRunInfo {
  SaveRunInfo(int queue, int created, int updated, int failed)
      : super(queue, created, updated, failed);

  factory SaveRunInfo.newRun() => SaveRunInfo(0, 0, 0, 0);

  @override
  void pushFunctionInQueue(String functionName) {
    super.pushFunctionInQueue(functionName);
    _updateSpinnerMessage();
  }

  @override
  void incrementFromAction(TestGenerationStatus status, String functionName) {
    super.incrementFromAction(status, functionName);
    _updateSpinnerMessage();
  }

  void _updateSpinnerMessage() {
    if (queue == 0) return;
    var methodList = '';
    if (queue > 3) {
      final functionQueueSubList = functionQueue.sublist(0, 3);
      methodList += functionQueueSubList.join(', ');
      methodList += ', and others';
    } else if (queue == 3) {
      final lastMethod = functionQueue.last;
      final functionQueueSubList = functionQueue.sublist(0, 2);
      methodList += functionQueueSubList.join(', ');
      methodList += ',and ${lastMethod}';
    } else if (queue == 2) {
      methodList += functionQueue.join(' and ');
    } else {
      final lastMethod = functionQueue.first;
      methodList += '${lastMethod}';
    }
    wtLog.updateSpinnerMessage('Saving Test for ${methodList}...');
  }
}
