class IntegrationRequestData {
  final String moduleName;
  final String precondition;
  final String testFlow;
  final List<Map<String, String>> testObjects;
  final List<ActiveScope> activeScopes;
  final String projectId;

  IntegrationRequestData({
    required this.moduleName,
    required this.precondition,
    required this.testFlow,
    required this.testObjects,
    required this.activeScopes,
    required this.projectId,
  });

  Map<String, dynamic> toJson() {
    return {
      'module_name': moduleName,
      'precondition': precondition,
      'test_flow': testFlow,
      'code_objects': testObjects,
      'active_scope': activeScopes.map((e) => e.toJson()).toList(),
      'project_id': projectId,
    };
  }
}

class ActiveScope {
  final String moduleName;
  final String precondition;
  final List<String> flow_hashes;

  ActiveScope({
    required this.moduleName,
    required this.flow_hashes,
    required this.precondition,
  });
  Map<String, dynamic> toJson() {
    return {
      "module_name": moduleName,
      "precondition": precondition,
      "flow_hashes": (flow_hashes)
    };
  }
}
