enum TestGenerationStatus { create, update, forceUpdate, failed }

class TestRunInfo {
  int queue;
  int created;
  int updated; //used in both generate and save
  int failed;

  var functionQueue = <String>[];
  var createdFunctions = <String>[];
  var updatedFunctions = <String>[];
  var successFunctions = <String>[];
  var failedFunctions = <String>[];

  TestRunInfo(
      this.queue, this.created, this.updated, this.failed);

  factory TestRunInfo.newRun() => TestRunInfo(0, 0, 0, 0);

  void pushFunctionInQueue(String functionName) {
    queue++;
    functionQueue.add(functionName);
  }

  void incrementFromAction(TestGenerationStatus status, String functionName) {
    if (queue <= 0) return;
    switch (status) {
      case TestGenerationStatus.create:
        created++;
        queue--;
        functionQueue.remove(functionName);
        createdFunctions.add(functionName);
        break;
      case TestGenerationStatus.update:
        updated++;
        queue--;
        functionQueue.remove(functionName);
        updatedFunctions.add(functionName);
        break;
      case TestGenerationStatus.forceUpdate:
        created++;
        queue--;
        functionQueue.remove(functionName);
        updatedFunctions.add(functionName);
        break;
      case TestGenerationStatus.failed:
        failed++;
        queue--;
        functionQueue.remove(functionName);
        failedFunctions.add(functionName);
        break;
    }
  }
}
