/*
 * Created on October 5th 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */

class ExtractedCode {
  String? code;
  AgentOperation operation;
  String name;

  ExtractedCode({
    this.code,
    required this.operation,
    required this.name,
  });

  factory ExtractedCode.fromRequirment(Map<String, dynamic> json) =>
      ExtractedCode(
        operation: json["operation"].toString().toEnum(),
        name: json["name"],
      );

  Map<String, dynamic> toJson() => {
        "name": name,
        "code": code,
      };
}

enum AgentOperation {
  getClass,
  getMethod,
}

extension AgentOperationEx on String {
  AgentOperation toEnum() => AgentOperation.values
      .firstWhere((d) => d.toString().split('.').last == this);
}
