/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'dart:io';
import 'package:path/path.dart' as p;

class PathUtils {
  static File correspondingPermanentTestFile(
      String functionName, File classFile) {
    final uri = Uri.file(
        testPath +
            Platform.pathSeparator +
            relatetiveLibFilePath(classFile.path).replaceAll(".dart", "") +
            "${Platform.pathSeparator}$functionName" +
            ".welltested_test.dart",
        windows: Platform.isWindows);
    return File.fromUri(uri);
  }

  static File correspondingPermanentWidgetTestFile(
      String widgetName, String widgetFilePath) {
    final uri = Uri.file(
        testPath +
            Platform.pathSeparator +
            relatetiveLibFilePath(widgetFilePath).replaceAll(".dart", "") +
            "${Platform.pathSeparator}$widgetName" +
            ".welltested_test.dart",
        windows: Platform.isWindows);
    return File.fromUri(uri);
  }

  static File correspondingIntegrationTestFile(String moduleName) {
    final uri = Uri.file(p.joinAll(
        [currentPath, "integration_test", '$moduleName.welltested_test.dart']));
    return File.fromUri(uri);
  }

  static String get currentPath => Directory.current.path;
  static String get libPath => p.join(currentPath, 'lib');
  static String get testPath => p.join(currentPath, 'test');
  static String get integrationTestPath =>
      p.join(currentPath, 'integration_test');
  static String get widgetTest => 'widget_tests';
  static String get flowsPath => p.join(integrationTestPath, "welltested.dart");

  static String relatetiveLibFilePath(String filePath) =>
      p.relative(filePath, from: libPath);
  static String relativeTestFilePath(String filePath) =>
      p.relative(filePath, from: testPath);

  static String absouteLibFilePath(String relativePath) =>
      p.join(libPath + '/' + relativePath);
  static String absouteTestFilePath(String relativePath) =>
      p.join(testPath + '/' + relativePath);
  static String absouteProjectFilePath(String relativePath) =>
      p.join(currentPath + '/' + relativePath);
}
